;////////////////
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5

initsd:
;Initalisation delay
; ============================= 
;   Warteschleifen-Generator 
;     8000000 Zyklen:
; ----------------------------- 
; warte 7999992 Zyklen:
          ldi  R17, $48
hWGLOOP0:  ldi  R18, $BC
hWGLOOP1:  ldi  R19, $C4
hWGLOOP2:  dec  R19
          brne hWGLOOP2
          dec  R18
          brne hWGLOOP1
          dec  R17
          brne hWGLOOP0
; ----------------------------- 
; warte 6 Zyklen:
          ldi  R17, $02
hWGLOOP3:  dec  R17
          brne hWGLOOP3
; ----------------------------- 
; warte 2 Zyklen:
          nop
          nop
; ============================= 
rcall lcd_clear
pulse:                      
	sbi   portB, 2              ; SS auf high
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
; SPI Modul konfigurieren
;-------------------------------------------------------------------------
    ldi temp1,(1<<SPE)|(1<<MSTR)|(1<<SPR0)| (1<<SPR1) ;f/128
    out SPCR, temp1
;-------------------------------------------------------------------------------
    ldi   temp1, 0
    out   SPSR,temp1            ; double speed deaktivieren (0) --aktivieren wre 1
;---------------------------------------------------------
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 74 Clock Impulse:
	sbi   portB, 2              ; SS auf high
	ldi   temp1, 0xFF
	rcall sende
	rcall sende
	rcall sende
	rcall sende
	rcall sende
	rcall sende
	rcall sende
	rcall sende
	rcall sende
	rcall sende                ;mind. 74 clock impulse
	rcall sende
	rcall sende
	rcall sende
	rcall sende
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
;__________________________________________IN DEN IDLE_MODE VERSETZEN:________
rcall anfang_befehl
CMD0:
ldi temp1, 0x40
rcall sende
ldi temp1, 0x00
rcall sende
ldi temp1, 0x00
rcall sende
ldi temp1, 0x00
rcall sende
ldi temp1, 0x00
rcall sende
ldi temp1, 0x95
rcall sende
  lp1:
  	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR
	cpi	temp1,	0x01			; Antwort sollte 0x01 sein
  brne lp1
OK_Idle_Mode:
           rcall lcd_number_hex
		   rcall ende_befehl
           ldi temp1, 'Y'     ; Zeichen anzeigen
           rcall lcd_data

;geht bis hierhin perfekt 01Y
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;%%%%%%%%%% Eigentliche Initalisierung mit CMD1 und HCS=1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;wichtig, bei der wiederholung von CMD1 muss SShigh bleiben, deswegen der refresh-dings nur einmal 
CMD55:
rcall anfang_befehl
ldi temp1, 0x77
rcall sende
ldi temp1, 0x00
rcall sende
rcall sende
rcall sende
rcall sende
rcall sende
  lp2:
	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 

	cpi	temp1,	0xFF			; Antwort sollte 0x01 oder 0x00 sein
  breq lp2
    
	cpi temp1,  0x01
  breq ACMD41    
  
    cpi temp1,  0x00
  breq ACMD41

;//////////////////////ERROR
mov r21, temp1
rcall lcd_clear
mov temp1, r21
rcall lcd_number_hex
rcall e
lp3:
rjmp lp3 

;/&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

ACMD41:
rcall ende_befehl
rcall anfang_befehl

ldi temp1, 0x69
rcall sende
ldi temp1, 0x00
rcall sende
rcall sende
rcall sende
rcall sende
rcall sende
  lp4:
	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 

	cpi	temp1,	0xFF			; Antwort sollte 0x00 sein
  breq lp4
    
	cpi temp1,  0x01
  breq ACMDnochmal    
  
    cpi temp1, 0x00
  breq fertig_init

;//////////////////////ERROR
mov r21, temp1
rcall lcd_clear
mov temp1, r21
rcall lcd_number_hex
rcall f
lp5:
rjmp lp5 
;---------------------------------------------
ACMDnochmal:
rcall ende_befehl
rjmp CMD55
;-------------------------------------------------------
fertig_init:
	       rcall lcd_number_hex
		   rcall ende_befehl
           ldi temp1, 'P'     ; Zeichen anzeigen
           rcall lcd_data
;geht bis hierhin 01Y00P
;---------------------------------------------------------------------------------------
rcall cupos9
;--------------
CMD16:
rcall anfang_befehl
ldi temp1, 0x50
rcall sende
ldi temp1, 0x00
rcall sende
rcall sende
ldi temp1, 0x02
rcall sende
ldi temp1, 0x00
rcall sende
ldi temp1, 0x00 ;0x01?
rcall sende
  lp41:
	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 

	cpi	temp1,	0xFF			; Antwort sollte 0x01 sein
   breq lp41    

    cpi temp1,  0x00
   breq fertig_init_16

;//////////////////////ERROR
mov r21, temp1
rcall lcd_clear
mov temp1, r21
rcall lcd_number_hex
rcall g
lp42:
rjmp lp42 
;///////////////////////
fertig_init_16:
           rcall lcd_number_hex
           rcall ende_befehl
           ldi temp1, 'P'     ; Zeichen anzeigen
           rcall lcd_data
; =============================bis hierhin gehts perfekt 01Y00P__00P
rcall wadde
;rcall wadde
ret

;'//////////////////////////////////////////////////////////////////
Kommando:
rcall anfang_befehl
ldi temp1, 0x58
rcall sende
mov temp1, Datum2
rcall sende
mov temp1, Datum3
rcall sende
mov temp1, Datum4
rcall sende
mov temp1, Datum5
rcall sende
ldi temp1, 0x00 
rcall sende

  lp6:
	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 
   cpi temp1, 0x00
  breq fertig_kommando
   cpi	temp1,	0xFF			; Antwort sollte 0x00 sein
  breq lp6    

;//////////////////////ERROR
rcall lcd_clear
rcall lcd_number_hex    ;hier kommt 0x20 an --> adress error
rcall h
lhmm:
rjmp lhmm 
;///////////////////////


fertig_kommando:
rcall lcd_clear
rcall ende_befehl
rcall o
rcall k
;deluxe geht

ret
;//////////////////////
ende_befehl:
sbi Portb, 2
  	ldi	temp1,	0xFF
	rcall sende 
	rcall sende			
ret
anfang_befehl:
cbi Portb, 2
ret
sende:  
	out	SPDR,	temp1
  lp8:	sbis	SPSR,	SPIF
	  rjmp	lp8
	ret
wadde:
;Initalisation delay
; ============================= 
;   Warteschleifen-Generator 
;     8000000 Zyklen:
; ----------------------------- 
; warte 7999992 Zyklen:
          ldi  R17, $48
hgWGLOOP0:  ldi  R18, $BC
hgWGLOOP1:  ldi  R19, $C4
hgWGLOOP2:  dec  R19
          brne hgWGLOOP2
          dec  R18
          brne hgWGLOOP1
          dec  R17
          brne hgWGLOOP0
; ----------------------------- 
; warte 6 Zyklen:
          ldi  R17, $02
hgWGLOOP3:  dec  R17
          brne hgWGLOOP3
; ----------------------------- 
; warte 2 Zyklen:
          nop
          nop
; ============================= 
ret
//########################################################
schreibe_abschnitt_512:
rcall Kommando //gibt "ok" aus
rcall anfang_befehl  //SUUPERWICHTIG

ldi temp1, 0xFE
rcall sende
//------------------------------
clr temp2
clr temp3	

st0:
ldi temp1, 'X'
rcall sende
inc temp2
cpi temp2, 255
breq st1
rjmp st0

st1:
clr temp2
inc temp3
cpi temp3, 2
breq st2
rjmp st0

st2:
ldi temp1, 'O'
rcall sende
ldi temp1, 'K'
rcall sende
;jetzt sinds 512 bytes

ldi temp1, 0x00
rcall sende
ldi temp1, 0x00
rcall sende
;die beiden CRC's
;und ende
//---------------------------------------------
EMPFANG_:

	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 

    push temp1
    andi temp1, 0x1F
	cpi temp1, 0x05
	breq lp9_
    pop temp1 

    cpi temp1, 0xFF
	breq empfang_


;//////////////////////ERROR
rcall lcd_clear
rcall lcd_number_hex    ;hier kommt 0x20 an --> adress error
rcall i
errors:
rjmp errors 
;///////////////////////
	 

	//rcall lcd_number_hex

  lp9_:
	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 

	cpi	temp1,	0xFF			; Antwort sollte 0x01 sein
   breq geschrieben_    

    cpi temp1,  0x00
   breq lp9_

geschrieben_:
//######################################################
;neuer sektor:  Datum2Datum3Datum4Datum5 + 0x0200
add Datum5, leer ; lowest byte
adc Datum4, zwei ;
adc Datum3, leer ;
adc Datum2, leer ; hchstes Byte


//frischen sektor fr nchsten Start in EEPROM saven
mov temp1, Datum2
rcall eeprom_write_1

mov temp1, Datum3
rcall eeprom_write_2

mov temp1, Datum4
rcall eeprom_write_3

mov temp1, Datum5
rcall eeprom_write_4


rcall lcd_clear
rcall bitte_ausschalten

endee:
rjmp endee

ret
