;letzter Stand: 25.12.07    1:23 Uhr  Geht deluxe, mit neuem Code zum Adresse im EEPROM speichern, um neuen GPS-Routen-Datenblock gut zu trennen 
.include "m8def.inc"                //Wenn man beim Start die Taste gedrckt hlt beim anschalten, dann gibts einen Adress-Reset auf sektor 61 (100)
.def leer = r12
.def voll = r14
.def zwei = r13
.def komma_hilfe = r15
.def temp1 = r16
;17-19 fr schleifen
.def temp2 = r20
.def temp3 = r27
.def kommastart = r21
.def Datum2 = r22
.def Datum3 = r23
.def Datum4 = r24
.def Datum5 = r25
.def komma = r26
.def GPS = r27
.def uni = r28
.def zahl = r29
;R30/r31 fr Z
.equ CLOCK = 8000000
.equ BAUD = 4800
.equ UBRRVAL = CLOCK/(BAUD*16)-1
.CSEG
.org 0x00
        rjmp main
 
.org URXCaddr
        rjmp int_rxc
main:

    ldi   temp1, LOW(RAMEND)     ; Stackpointer initialisieren
    out   SPL, temp1
    ldi   temp1, HIGH(RAMEND)
    out   SPH, temp1

    ldi temp1, 0xFF    ; Port C = Ausgang fr LCD
    out DDRC, temp1
    ldi temp1, 0b11101100  ; SCK, MOSI, SS als Ausgnge schalten ; MISO ist sowiso eingang bei Master-konfiguration
    out DDRB, temp1
	
///////////////////////////////////////////////////////////UART konfig
       ; Baudrate einstellen
        ldi temp1, LOW(UBRRVAL)
        out UBRRL, temp1
        ldi temp1, HIGH(UBRRVAL)
        out UBRRH, temp1
 
        ; Frame-Format: 8 Bit
        ldi temp1, (1<<URSEL)|(3<<UCSZ0)
        out UCSRC, temp1

        sbi UCSRB, RXCIE                  ; Interrupt bei Empfang
        sbi UCSRB, RXEN                   ; RX (Empfang) aktivieren
		;sbi UCSRB, TXEN                     
///////////////////////////////////////////////////////////////////////////////
	       rcall lcd_init     ; Display initialisieren
           rcall lcd_clear    ; Display lschen
		   rcall GPS_Logger
		   
		   sbis Pinb, 0       ;bei gedrckter taste EEPROM-Adresse resetten
            rjmp nichts 
	   rcall EEPROM_reset   
		    nichts:

		   rcall wadde
		   rcall wadde
//////////////////////////////////////////////////////////////////////////////
rcall InitSD
rcall clear_sram

LDI ZH, HIGH(0x0060)
LDI ZL, LOW(0x0060)
////////////////////////////////REGISTER-BELADUNGEN
ldi temp1, 6
mov komma_hilfe, temp1
ldi temp1, 2
mov zwei, temp1
ldi temp1, 0xFF
mov voll, temp1
ldi temp1, 0x00
mov leer, temp1
ldi uni, 0x21

ldi GPS, 'V'

ldi zahl, 'A' //fr Beginn 
////////////////////////////////LCD-start
rcall lcd_clear
rcall nicht_bereit
////////////////////////////////Start-adresse auf SD-Karte aus EEPROM lesen
rcall SD_Startadresse_lesen

//ldi Datum2, 0x00    ;high-byte
//ldi Datum3, 0x00
//ldi Datum4, 0xC8
//ldi Datum5, 0x00    ;low byte       --> sektor 100
////////////////////////////////////////Testweise
;ldi GPS, 'J'
;rcall lcd_clear
;rcall GPS_bereit
////////////////////////////////////////////////////////////////////////////alle Einstellungen fertig, nur noch:
        sei     ; Interrupts berhaupt aktivieren
loop:
sbis Pinb, 0
rjmp loop

ldi uni, 'H'
rjmp loop



int_rxc:
;--------------
clr temp1                         
in temp1, UDR
;**Initalisierungs-abfrage**
;-----------------------------------------------------
;Zustnde abfragen:        ******* zustzlicher code funktionstchtig? nach Zeichenfolge GG komma zhlen... 
cpi GPS, 'J'                                 ;event. mit PG als codefolge probieren.
breq OK_Daten_uebernehmen
cpi GPS, 'V'
breq VorGG 
cpi GPS, 'G'
breq einG
cpi GPS, 'Z'
breq kommma_zaehlen
;--------------
VorGG:
cpi temp1, 'G'
breq Gsetzen
reti

einG:
cpi temp1, 'G'
breq Zsetzen
ldi GPS, 'V'
reti

Zsetzen:
ldi GPS, 'Z'
reti

Gsetzen:
ldi GPS, 'G'
reti
/////////////////////////////////////**********
kommma_zaehlen:
cp komma, komma_hilfe
breq gueltig
cpi temp1, ','
breq ein_komma_mehr;bei zeichen nach 6./22.Komma:
reti

ein_komma_mehr:
inc komma
reti

gueltig:
cpi temp1, '1'
breq GPS_ok
/////////////anzeige_GPS_init
push temp1
rcall cupos15
pop temp1
rcall lcd_data
inc uni
mov temp1, uni
rcall lcd_data
////////////
clr komma
ldi GPS, 'V'  ;sonst halt zu zustand VorGG springen
reti

GPS_ok:
ldi GPS, 'J'
rcall lcd_clear
rcall GPS_bereit
clr uni
reti
//************************************************************************
OK_Daten_uebernehmen:

ST Z+, temp1
;rcall lcd_data

cpi ZH, 0x02
breq highb_fertig
rjmp weiter_emp
highb_fertig:
cpi ZL, 0x5F
breq finito
weiter_emp:

;**********************************************
;**********************************************
;--------------Zustnde abfragen:        ******* zustzlicher code funktionstchtig? nach Zeichenfolge GG komma zhlen... 
cpi zahl, 'A'                                 ;event. mit PG als codefolge probieren.
breq vorV
cpi zahl, 'B'
breq vorN 
cpi zahl, 'C'
breq anzeigen_C

;--------------
VorV:            ;Gerade im Zustand A
cpi temp1, 'V'   ;fr den VTG-Datensatz
breq Bsetzen
rjmp hep

vorN:
cpi temp1, 'N'  ;gerade im Zustand B
breq Csetzen
rjmp hep


anzeigen_C:     ;gerade im Zustand C
cpi temp1, 'K'
breq Asetzen
rcall lcd_data
rjmp hep

Bsetzen:
ldi zahl, 'B'
rjmp hep

Csetzen:
ldi zahl, 'C'
rcall lcd_clear ;
rjmp hep

Asetzen:
ldi zahl, 'A'
rjmp hep

;**********************************************
;**********************************************
hep:
reti
;geht, wenn auch mit kleinen fehlern(manchmal ist GPVTG-Prot nicht vollstndig.


/////////////////////////////////////////////////////////////////////////////////


clear_sram:
LDI ZH, HIGH(0x0060)
LDI ZL, LOW(0x0060)
ldi temp1, '.'
leere:
cpi ZL, (LOW(RAMEND-2))  ; fr den stack ist schon bei ramend-2 schluss
breq oh_
rjmp weiterr_
oh_:
cpi ZH, HIGH(RAMEND-2)
breq nix_
weiterr_:
ST Z+, temp1
rjmp leere
nix_:
ret

/////////////////////////////////////////////////////////////////////////////////
finito:

;rcall lcd_home
;rcall k
;startadresse von sram auf 0060
LDI ZH, HIGH(0x0060)
LDI ZL, LOW(0x0060)
rcall l
;auf sd-karte schreiben
CMD24:
;ldi Datum2, 0x03
;ldi Datum3, 0xC2
;ldi Datum4, 0x72
;ldi Datum5, 0x00  ;123193  entspricht logical sector 123154
;rcall m
rcall Kommando  ;schreiben anfang fehler
;rcall n
rcall anfang_befehl

ldi temp1, 0xFE
rcall sende

;rcall lcd_home
;rcall o

////////////////////////512 bytes von sram ab 0x0060 bis 0x025F in einen sektor der sd-karte schreiben
weiter_emp_:

LD  temp1, Z+           ;von 0060 anfangen bis:
rcall sende             ;daten bergeben

cpi ZH, 0x02            ;bei sram-adresse start (0x0060) + 511 ist schluss
breq highb_fertig_
rjmp weiter_emp_
highb_fertig_:
cpi ZL, 0x5F            ;bei sram-adresse start (0x0060) + 511 ist schluss
breq finitop
rjmp weiter_emp_

finitop:

////////////////////////

ldi temp1, 0x00
rcall sende
ldi temp1, 0x00
rcall sende

;die beiden CRC's
;und ende

EMPFANG:

	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 
    cpi temp1, 0xFF
	breq empfang
	rcall lcd_number_hex

  lp9:
	ldi	temp1,	0xFF
	rcall	sende 				;//Wartet auf ein gltige Antwort von der MMC/SD-Karte
	in	temp1,	SPDR 

	cpi	temp1,	0xFF			; Antwort sollte 0x01 sein
   breq geschrieben    

    cpi temp1,  0x00
   breq lp9

geschrieben:
rcall lcd_clear
rcall s
rcall p
rcall e
rcall i
rcall c
rcall h
rcall e
rcall r
;rcall wadde

;neuer sektor:  Datum2Datum3Datum4Datum5 + 0x0200
add Datum5, leer ; lowest byte
adc Datum4, zwei ;
adc Datum3, leer ;
adc Datum2, leer ; hchstes Byte

cpi uni, 'H'
breq Herunterfahren

 
;startadresse von sram auf 0060
LDI ZH, HIGH(0x0060)
LDI ZL, LOW(0x0060)

ldi zahl, 'A'  ;fr Geschwindigkeitsanzeige

reti ; und wieder zurck
;geht deluxemssiggschmeidigsuper
;////////////////////////////////////////////////////////////////////////////////////////////////////////
Herunterfahren:
cli
rcall lcd_clear
rcall aus_text

rcall schreibe_abschnitt_512// in eigenen sektor ***ok schreiben --> bedeutet: alle vorigen Daten gehren zu eigener GPS-Strecke

lp11:
rjmp lp11


///////////////////////////

;///////////////////////////////////////////////////////////////////////////////////////////////////
; 8 Bits aus temp1 an das Schieberegister ausgeben


.include "lcd-routines.asm"            ; LCD-Routinen werden hier eingefgt 
.include "abc0-9V2.asm"
.include "SD_init.asm"
.include "eeprom.asm"
.include "locate.asm"
.ESEG

.org 0x0001
.db 0

.org 0x0002
.db 0

.org 0x0003
.db 0xC8

.org 0x0004
.db 0

///////////////////////auskommentierter kram
;ldi Datum2, 0x03
;ldi Datum3, 0xC2
;ldi Datum4, 0x72
;ldi Datum5, 0x00  ;123193  entspricht logical sector 123154
