EEPROM_write_1:
    sbic    EECR, EEWE                  ; prfe ob der letzte Schreibvorgang beendet ist
    rjmp    EEPROM_write_1                ; wenn nein, nochmal prfen

ldi temp2, 0 
ldi temp3, 1


    out     EEARH, temp2                   ; Adresse 0 schreiben
    out     EEARL, temp3               ; 
    out     EEDR,temp1                   ; Daten  schreiben
  in      temp2,sreg              
	cli                                 ; Interrupts sperren, die nchsten                                        ; unterbrochen werden
    sbi     EECR,EEMWE                  ; Schreiben vorbereiten
    sbi     EECR,EEWE                   ; Und los !
  out     sreg, temp2             ; SREG wieder herstellen

ret

EEPROM_write_2:
    sbic    EECR, EEWE                  ; prfe ob der letzte Schreibvorgang beendet ist
    rjmp    EEPROM_write_2               ; wenn nein, nochmal prfen

ldi temp2, 0 
ldi temp3, 2

    out     EEARH, temp2                   ; Adresse 0 schreiben
    out     EEARL, temp3               ; 
    out     EEDR,temp1                   ; Daten  schreiben
    
	in      temp2,sreg              
	
	cli                                 ; Interrupts sperren, die nchsten                                        ; unterbrochen werden
    sbi     EECR,EEMWE                  ; Schreiben vorbereiten
    sbi     EECR,EEWE                   ; Und los !
    out     sreg, temp2             ; SREG wieder herstellen
ret
EEPROM_write_3:
    sbic    EECR, EEWE                  ; prfe ob der letzte Schreibvorgang beendet ist
    rjmp    EEPROM_write_3                ; wenn nein, nochmal prfen

ldi temp2, 0 
ldi temp3, 3

    out     EEARH, temp2                   ; Adresse 0 schreiben
    out     EEARL, temp3               ; 
    out     EEDR,temp1   
	
	in      temp2,sreg              
             
    cli                                 ; Interrupts sperren, die nchsten                                        ; unterbrochen werden
    sbi     EECR,EEMWE                  ; Schreiben vorbereiten
    sbi     EECR,EEWE                   ; Und los !
out     sreg, temp2             ; SREG wieder herstellen
ret

EEPROM_write_4:
    sbic    EECR, EEWE                  ; prfe ob der letzte Schreibvorgang beendet ist
    rjmp    EEPROM_write_4               ; wenn nein, nochmal prfen

ldi temp2, 0 
ldi temp3, 4

    out     EEARH, temp2                   ; Adresse 0 schreiben
    out     EEARL, temp3               ; 
    out     EEDR,temp1                   ; Daten  schreiben
    
	in      temp2,sreg              

	cli                                 ; Interrupts sperren, die nchsten                                        ; unterbrochen werden
    sbi     EECR,EEMWE                  ; Schreiben vorbereiten
    sbi     EECR,EEWE                   ; Und los !
out     sreg, temp2             ; SREG wieder herstellen
ret


SD_Startadresse_lesen:
EEPROM_read_1:
    sbic    EECR,EEWE                   ; prfe ob der vorherige Schreibzugriff
                                        ; beendet ist
    rjmp    EEPROM_read_1                 ; nein, nochmal prfen

ldi temp3, 0
ldi temp2, 1

    out     EEARH, temp3                  ; Adresse laden
    out     EEARL, temp2 

    sbi     EECR, EERE                  ; Lesevorgang aktivieren

    in      Datum2, EEDR                   ; Daten in CPU Register kopieren

EEPROM_read_2:
    sbic    EECR,EEWE                   ; prfe ob der vorherige Schreibzugriff
                                        ; beendet ist
    rjmp    EEPROM_read_2                 ; nein, nochmal prfen

ldi temp3, 0
ldi temp2, 2

    out     EEARH, temp3                  ; Adresse laden
    out     EEARL, temp2 

    sbi     EECR, EERE                  ; Lesevorgang aktivieren

    in      Datum3, EEDR                   ; Daten in CPU Register kopieren

EEPROM_read_3:
    sbic    EECR,EEWE                   ; prfe ob der vorherige Schreibzugriff
                                        ; beendet ist
    rjmp    EEPROM_read_3               ; nein, nochmal prfen

ldi temp3, 0
ldi temp2, 3

    out     EEARH, temp3                  ; Adresse laden
    out     EEARL, temp2 

    sbi     EECR, EERE                  ; Lesevorgang aktivieren

    in      Datum4, EEDR                   ; Daten in CPU Register kopieren

EEPROM_read_4:
    sbic    EECR,EEWE                   ; prfe ob der vorherige Schreibzugriff
                                        ; beendet ist
    rjmp    EEPROM_read_4                 ; nein, nochmal prfen

ldi temp3, 0
ldi temp2, 4

    out     EEARH, temp3                  ; Adresse laden
    out     EEARL, temp2 

    sbi     EECR, EERE                  ; Lesevorgang aktivieren

    in      Datum5, EEDR                   ; Daten in CPU Register kopieren

ret

EEPROM_reset:
rcall lcd_clear
rcall lcd_eeprom_reset

ldi Datum2, 0x00    ;high-byte
ldi Datum3, 0x00
ldi Datum4, 0xC8
ldi Datum5, 0x00    ;low byte       --> sektor 61 (100)

mov temp1, Datum2
rcall eeprom_write_1

mov temp1, Datum3
rcall eeprom_write_2

mov temp1, Datum4
rcall eeprom_write_3

mov temp1, Datum5
rcall eeprom_write_4
ret
